MultiTips =  AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceHook-2.1") 
MULTITIPS_LOADED=0


function MultiTips:OnInitialize()
	frames_used={0,0,0,0,0}
	frames_links={0,0,0,0,0}
	MULTITIPS_LOADED=1
		
	local options = { 
    type="group",
    args = {
    	clear= {
    		type="execute",
    		name="Close all Tips",
    		desc="Close all Tips",
    		func=function(v) MultiTips:CloseAllTips() end,
    	},
		}
	}
	MultiTips:RegisterChatCommand({"/multitips"}, options)
end

function MultiTips:OnEnable()
	local frames_used={0,0,0,0,0}
	local frames_links={0,0,0,0,0}
	self:Hook("SetItemRef", "SetItemRef", true)
	self:SecureHook("HideUIPanel")
end

function MultiTips:OnDisable()
	self:UnhookAll()
end


function MultiTips:SetItemRef(link, text, button)
	if ( strsub(link, 1, 6) == "player" ) then
		self.hooks["SetItemRef"](link,text,button);
		return
	end

	if ( IsControlKeyDown() ) then
		self.hooks["SetItemRef"](link,text,button);
	elseif ( IsShiftKeyDown() ) then
		self.hooks["SetItemRef"](link,text,button);
	else
		MultiTips:Handler(link, text, button)
	end
end

function MultiTips:HideUIPanel(frame)
	if frame == ItemRefTooltip or frame == ItemRefTooltip2 or frame == ItemRefTooltip3 or frame == ItemRefTooltip4 or frame == ItemRefTooltip5 then
		if IsShiftKeyDown() then 
			self:CloseAllTips()
		else 
		 	MultiTips:RemoveTip(frame)
		end
	end
end

function MultiTips:CloseAllTips()
		MultiTips:RemoveTip(ItemRefTooltip)
		if ItemRefTooltip:IsVisible() then HideUIPanel(ItemRefTooltip) end
		
		MultiTips:RemoveTip(ItemRefTooltip2)
		if ItemRefTooltip2:IsVisible() then HideUIPanel(ItemRefTooltip2) end
		
		MultiTips:RemoveTip(ItemRefTooltip3)
		if ItemRefTooltip3:IsVisible() then HideUIPanel(ItemRefTooltip3) end
		
		MultiTips:RemoveTip(ItemRefTooltip4)
		if ItemRefTooltip4:IsVisible() then HideUIPanel(ItemRefTooltip4) end
		
		MultiTips:RemoveTip(ItemRefTooltip5)
		if ItemRefTooltip5:IsVisible() then HideUIPanel(ItemRefTooltip5) end
end

function MultiTips:Handler(link, text, button)
  self:Clean()
  local a
  a=self:CheckForExistingLink(link)
  if a==0 then
		local i
		i=self:GetFreeIndex()
		local temp
		if i==1 then temp=ItemRefTooltip end
		if i==2 then temp=ItemRefTooltip2 end
		if i==3 then temp=ItemRefTooltip3 end
		if i==4 then temp=ItemRefTooltip4 end
		if i==5 then temp=ItemRefTooltip5 end
		if i==-1 then self:Print("All tips are used. Close a tip before being able to open a new one. (Shift-close to close them all)") return end
		ShowUIPanel(temp)
		if ( not temp:IsVisible() ) then
			temp:SetOwner(UIParent, "ANCHOR_PRESERVE");
		end
		temp:SetHyperlink(link);
		frames_used[i]=1	
		frames_links[i]=link
	else 
		if a==1 then if ItemRefTooltip:IsVisible() then HideUIPanel(ItemRefTooltip) end end	
		if a==2 then if ItemRefTooltip2:IsVisible() then HideUIPanel(ItemRefTooltip2) end end	
		if a==3 then if ItemRefTooltip3:IsVisible() then HideUIPanel(ItemRefTooltip3) end end	
		if a==4 then if ItemRefTooltip4:IsVisible() then HideUIPanel(ItemRefTooltip4) end end	
		if a==5 then if ItemRefTooltip5:IsVisible() then HideUIPanel(ItemRefTooltip5) end end	
	end
end

function MultiTips:RemoveTip(frame)
	if MULTITIPS_LOADED==1 then 
		local i
		if frame==ItemRefTooltip then i=1 end
		if frame==ItemRefTooltip2 then i=2 end
		if frame==ItemRefTooltip3 then i=3 end
		if frame==ItemRefTooltip4 then i=4 end
		if frame==ItemRefTooltip5 then i=5 end
		if i==1 or i==2 or i==3 or i==4 or i==5 then 
			frames_used[i]=0 
			frames_links[i]=0
			end
	end
end

function MultiTips:GetFreeIndex()
	 for i=1,table.getn(frames_used) do 
	 	if frames_used[i]==0 then return i end
	 end
	 return -1
end

function MultiTips:CheckForExistingLink(link)
	a=0
	for i=1,table.getn(frames_links) do 
		if frames_links[i]== link then a=i end
	end
	return a
end

function MultiTips:TipClicked(i,tip)
	if arg1=="RightButton" and ItemRefTooltip:IsVisible() and tip:IsVisible() then 
		local blizlink=frames_links[1]
		local tiplink=frames_links[i]
		
		local point,relativeTo,relativePoint,xOfs,yOfs = ItemRefTooltip:GetPoint()
		local point2,relativeTo2,relativePoint2,xOfs2,yOfs2 = tip:GetPoint()

		ItemRefTooltip:SetPoint(point2,relativeTo2,relativePoint2,xOfs2,yOfs2)
		tip:SetPoint(point,relativeTo,relativePoint,xOfs,yOfs)
		
		if tip:IsVisible() then HideUIPanel(tip) end
		if ItemRefTooltip:IsVisible() then HideUIPanel(ItemRefTooltip) end
		
		MultiTips:Handler(tiplink, "a", "LeftButton")
		MultiTips:Handler(blizlink, "a", "LeftButton")
	elseif arg1=="RightButton" and tip:IsVisible() then 
		local tiplink=frames_links[i]
		
		local point2,relativeTo2,relativePoint2,xOfs2,yOfs2 = tip:GetPoint()

		ItemRefTooltip:SetPoint(point2,relativeTo2,relativePoint2,xOfs2,yOfs2)
		
		if tip:IsVisible() then HideUIPanel(tip) end
		
		MultiTips:Handler(tiplink, "a", "LeftButton")					
	end
end

function MultiTips:Clean()
	if not ItemRefTooltip:IsVisible() then 
		frames_used[1]=0 
		frames_links[1]=0
	end
	if not ItemRefTooltip2:IsVisible() then 
		frames_used[2]=0 
		frames_links[2]=0
	end
	if not ItemRefTooltip3:IsVisible() then 
		frames_used[3]=0 
		frames_links[3]=0
	end
	if not ItemRefTooltip4:IsVisible() then 
		frames_used[4]=0 
		frames_links[4]=0
	end
	if not ItemRefTooltip5:IsVisible() then 
		frames_used[5]=0 
		frames_links[5]=0
	end
end